
#include <iostream.h>
#include <fstream.h>
#include "echo.h"

class Echo_impl : virtual public POA_Echo
{
  public:

  void echoString(const char *str ){ fprintf(stdout,"[Server]%s\n", str); };

};

int main( int argc, char *argv[] )
{

   CORBA::ORB_var orb = CORBA::ORB_init( argc, argv, "mico-local-orb" );

   CORBA::Object_var poa_obj = orb->resolve_initial_references ( "RootPOA" );
   PortableServer::POA_var poa = PortableServer::POA::_narrow (poa_obj);
   PortableServer::POAManager_var poa_mgr = poa->the_POAManager();

   Echo_impl *servant = new Echo_impl;


   PortableServer::ObjectId_var oid = poa->activate_object (servant);

   CORBA::Object_var ref = poa->id_to_reference ( oid.in() );
   CORBA::String_var oid_str = orb->object_to_string ( ref.in() );
   ofstream out ("echo.ior");
   out << oid_str.in() ;
   out.close();


   fprintf(stderr,"***Server running\n");
   poa_mgr->activate();
   orb->run();

   poa->destroy ( TRUE, TRUE);
   delete servant;
   return 0;
}
